import * as basicValidation from "./basicValidation.cjs";
/**
 * This function validates the inputs of a PUT request on /booking/{ID}/lock
 */
export function validatePutBookingByIDLockInput(parameters) {
    if (parameters) {
        if (!basicValidation.validateIDRequest(parameters["ID"])) {
            validatePutBookingByIDLockInput.errors = basicValidation.validateIDRequest.errors;
            return false;
        }
    }
    else {
        return false;
    }
    return true;
}
/**
 * This function validates the outputs to a PUT request on /booking/{ID}/lock
 */
export function validatePutBookingByIDLockOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!basicValidation.validatePutBookingByIDLockResponse200Response(response.body)) {
            validatePutBookingByIDLockOutput.errors = basicValidation.validatePutBookingByIDLockResponse200Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 412) {
        return true;
    }
    if (response.status === 500) {
        if (!basicValidation.validatePutBookingByIDLockResponse500Response(response.body)) {
            validatePutBookingByIDLockOutput.errors = basicValidation.validatePutBookingByIDLockResponse500Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 503) {
        return true;
    }
    validatePutBookingByIDLockOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
/**
 * This function validates the inputs of a DELETE request on /booking/{ID}/lock
 */
export function validateDeleteBookingByIDLockInput(parameters) {
    if (parameters) {
        if (!basicValidation.validateIDRequest(parameters["ID"])) {
            validateDeleteBookingByIDLockInput.errors = basicValidation.validateIDRequest.errors;
            return false;
        }
    }
    else {
        return false;
    }
    return true;
}
/**
 * This function validates the outputs to a DELETE request on /booking/{ID}/lock
 */
export function validateDeleteBookingByIDLockOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 412) {
        return true;
    }
    if (response.status === 500) {
        if (!basicValidation.validateDeleteBookingByIDLockResponse500Response(response.body)) {
            validateDeleteBookingByIDLockOutput.errors = basicValidation.validateDeleteBookingByIDLockResponse500Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 503) {
        return true;
    }
    validateDeleteBookingByIDLockOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
/**
 * This function validates the inputs of a POST request on /booking_callback/{ID}
 */
export function validatePostBookingCallbackByIDInput(parameters) {
    if (parameters) {
        if (!basicValidation.validateIDRequest(parameters["ID"])) {
            validatePostBookingCallbackByIDInput.errors = basicValidation.validateIDRequest.errors;
            return false;
        }
    }
    else {
        return false;
    }
    return true;
}
/**
 * This function validates the outputs to a POST request on /booking_callback/{ID}
 */
export function validatePostBookingCallbackByIDOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        if (!basicValidation.validatePostBookingCallbackByIDResponse500Response(response.body)) {
            validatePostBookingCallbackByIDOutput.errors = basicValidation.validatePostBookingCallbackByIDResponse500Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 503) {
        return true;
    }
    validatePostBookingCallbackByIDOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
//# sourceMappingURL=requestValidation.js.map