/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
import express from "express";
import operations from "../operations/index.js";
import { ValidationError } from "./types.js";
import { validatePutBookingByIDLockInput, validatePutBookingByIDLockOutput, validateDeleteBookingByIDLockInput, validateDeleteBookingByIDLockOutput, validatePostBookingCallbackByIDInput, validatePostBookingCallbackByIDOutput } from "./requestValidation.js";
export default function router() {
    const router = express.Router();
    router.put("/booking/:ID/lock", async (req, res, next) => {
        const parameters = {
            "ID": req.params["ID"]
        };
        try {
            if (!validatePutBookingByIDLockInput(parameters)) {
                throw new ValidationError("Request validation failed", validatePutBookingByIDLockInput.errors, 400);
            }
            const result = await operations.putBookingByIDLock(req, parameters);
            if (!validatePutBookingByIDLockOutput(result)) {
                throw new ValidationError("Response validation failed", validatePutBookingByIDLockOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).json(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete("/booking/:ID/lock", async (req, res, next) => {
        const parameters = {
            "ID": req.params["ID"]
        };
        try {
            if (!validateDeleteBookingByIDLockInput(parameters)) {
                throw new ValidationError("Request validation failed", validateDeleteBookingByIDLockInput.errors, 400);
            }
            const result = await operations.deleteBookingByIDLock(req, parameters);
            if (!validateDeleteBookingByIDLockOutput(result)) {
                throw new ValidationError("Response validation failed", validateDeleteBookingByIDLockOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).json(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/booking_callback/:ID", async (req, res, next) => {
        const parameters = {
            "ID": req.params["ID"]
        };
        try {
            if (!validatePostBookingCallbackByIDInput(parameters)) {
                throw new ValidationError("Request validation failed", validatePostBookingCallbackByIDInput.errors, 400);
            }
            const result = await operations.postBookingCallbackByID(req, parameters);
            if (!validatePostBookingCallbackByIDOutput(result)) {
                throw new ValidationError("Response validation failed", validatePostBookingCallbackByIDOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).json(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    return router;
}
//# sourceMappingURL=routes.js.map