import { validateUserType, validateUserTypeRequest, validateUserTypeResponse } from "./basicValidation.cjs";
export function isSuccessResponse(response) {
    return response.status < 400;
}
export function isErrorResponse(response) {
    return response.status >= 400;
}
export class ErrorWithStatus extends Error {
    status;
    constructor(message, status) {
        super(message);
        this.status = status;
        this.name = "ErrorWithStatus";
    }
}
export class ValidationError extends ErrorWithStatus {
    errors;
    constructor(message, errors, status) {
        super(message, status);
        this.name = "ValidationError";
        this.errors = errors;
    }
}
export function isUserType(obj, type = "all") {
    switch (type) {
        case "request":
            return validateUserTypeRequest(obj);
        case "response":
            return validateUserTypeResponse(obj);
        default:
            return validateUserType(obj);
    }
}
//# sourceMappingURL=types.js.map